#ifndef MYTH_LIVETV_H_
#define MYTH_LIVETV_H_

#include <glib-object.h>

#include <gmyth/gmyth_remote_encoder.h>
#include <gmyth/gmyth_tvchain.h>
#include <gmyth/gmyth_common.h>

#include "myth_file_transfer.h"

#define G_BEGIN_DECLS

#define MYTH_LIVETV_TYPE               (myth_livetv_get_type ())
#define MYTH_LIVETV(obj)               (G_TYPE_CHECK_INSTANCE_CAST ((obj), MYTH_LIVETV_TYPE, MythLiveTV))
#define MYTH_LIVETV_CLASS(klass)       (G_TYPE_CHECK_CLASS_CAST ((klass), MYTH_LIVETV_TYPE, MythLiveTVClass))
#define IS_MYTH_LIVETV(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), MYTH_LIVETV_TYPE))
#define IS_MYTH_LIVETV_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), MYTH_LIVETV_TYPE))
#define MYTH_LIVETV_GET_CLASS(obj)     (G_TYPE_INSTANCE_GET_CLASS ((obj), MYTH_LIVETV_TYPE, MythLiveTVClass))

typedef struct _MythLiveTV         MythLiveTV;
typedef struct _MythLiveTVClass    MythLiveTVClass;

struct _MythLiveTVClass
{
  GObjectClass parent_class;

  /* callbacks */
};

struct _MythLiveTV
{
	GObject parent;

	// Backend connection related variables
	GString *backend_hostname;
	gint backend_port;
	GString *local_hostname;

	GMythRemoteEncoder *remote_encoder;
	GMythTVChain *tvchain;
	GMythProgramInfo *proginfo;

	gboolean is_livetv;

};

GType          myth_livetv_get_type (void);

MythLiveTV* myth_livetv_new ();

void myth_livetv_start_playing (MythLiveTV *livetv);
void myth_livetv_stop_playing (MythLiveTV *livetv);

gboolean myth_livetv_setup (MythLiveTV *livetv);

#define G_END_DECLS

#endif /*MYTH_LIVETV_H_*/
